#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_object4xi.py">
#<abstract4xi abstract = "tests object4xi"/>
#<verify4xi verification = "11" target = "object4xi.py"/>
#<contextualize4xi context = "object4xi"/>
#<use4xi usage = "
# 
# SELECT (options are rarely used):
# 1) if debug2analyze is True <-- ANALYZE VERBS USING FUNCTION (OPTIONAL)
# - default False
# 2) if debug2wave is True <-- WAVE VERBS BY FUNCTION (OPTIONAL)
# - default False
# 3) if debug2sense is True <-- SENSE BY FUNCTION (OPTIONAL)
# - default False
# 4) if debug2reason is True <-- REASON BY FUNCTION (OPTIONAL)
# - default False
# 5) if debug2ace is True <-- ACE BY FUNCTION (OPTIONAL)
# - default False
# 6) if debug2analyze is True <-- ANALYZE BY CLASS (OPTIONAL)
# - default False
# 7) if debug2color is True <-- COLOR TENSES BY CLASS (OPTIONAL)
# - default False
# 
# ALWAYS DONE:
# 8) v2xi.coordinate_tenses('..//..//xml//reason-test-skeleton-print4xi.xml')
# - creates verbs from input Python file
# 
# RUN:
# 1) > call t test_object4xi > ..\txt\test_object4xi.txt
# 2) > call t test_noun4xi > ..\txt\test_noun4xi.txt <-- set ..//..//xml//ace-test-object4xi.xml': 'nack' in test_noun4xi.py 
#
# ANALYZE:
# reason-verb4xi.xml           <-- all available trace verbs!
# scope-ace-test-object4xi.xml <-- scope file (make sure test_noun4xi.py setting is ok)
# sense-test-object4xi.xml     <-- trace in XML
# reason-test-object4xi.xml
# ace-test-object4xi.xml
# test_object4xi.txt           <-- textual trace
#"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'print_trace4xi',
            'test_object4xi',            
            'set_trace4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging  
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi  

from print4xi import Print4Xi
from print4xi import print4xi
from print4xi import set_print_permission4xi

from skeleton_print4xi import SkeletonPrint4Xi
from skeleton_print4xi import skeleton_print4xi
from skeleton_print4xi import sense_function4xi
from skeleton_print4xi import reason_function4xi
from skeleton_print4xi import ace_function4xi

from time4xi import time4xi

from verb4xi import Verb4Xi
from verb4xi import analyze_verb4xi
from verb4xi import wave_verb4xi
from verb4xi import color_tenses4xi 
from verb4xi import sense_verb4xi
from verb4xi import reason_verb4xi
from verb4xi import ace_verb4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi  


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        # 'ace_verb4xi': 'NACK4TRACE',
        # 'analyze_verb4xi': 'NACK4TRACE',
        # 'color_tenses4xi': 'NACK4TRACE',
        'DummyProcess4Xi': 'NACK4TRACE'    # <-- limited trace to this minimize trace output
        # 'Pipe4Xi': 'NACK4TRACE',
        # 'Process4Xi': 'NACK4TRACE',
        # 'Queue4Xi': 'NACK4TRACE',
        # 'reason_verb4xi': 'NACK4TRACE',
        # 'sense_verb4xi': 'NACK4TRACE',
        # 'wave_verb4xi': 'NACK4TRACE',
        # 'Verb4Xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-object4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Object in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Object in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-object4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Object in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Object in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-object4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Object in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Object in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
 
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-verbkb4xi" usage = "
# tests verbkb4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_object4xi():
    global t2xi
    global trace_object_count    
          
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(STEP 0/33) OF TEST_OBJECT4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    

    # ---------------------------------------------------------------------------------------------------------
    # OBJECT                
    # ---------------------------------------------------------------------------------------------------------    
    try:
         
        # ---------------------------------------------------------------------------------------------
        # START                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 1/33) OF TEST_OBJECT4XI: STARTING ', time4xi())
        print('=' *33)   
        
        debug2analyze = False
        
        if debug2analyze is True:
            # ---------------------------------------------------------------------------------------------
            # ANALYZE VERBS USING FUNCTION - OPTIONAL                          
            # ---------------------------------------------------------------------------------------------    
            print('=' *33)          
            print('(Step 2/33) OF TEST_OBJECT4XI: ANALYZE VERBS BY FUNCTION')
            print('=' *33)      
            
            kb2xi = analyze_verb4xi()
            keys2kb = kb2xi.keys() 
    
            print('=' *70) 
            print("(Step 3/33) OF TEST_OBJECT4XI: ANALYZED VERBS BY FUNCTION KNOWLEDGE:")
            
            
            for key2kb in sorted(keys2kb):
                print('\n', key2kb, ' : ', kb2xi[key2kb])
                
            # =================================
            # VERB:  zero
            # DEFINITION OF  zero -VERB:  to amount to zero.
            # REFERENCE OF  zero -VERB:  2209
            # SYMBOL OF  zero -VERB:  2209
            # CLUSTER OF  zero -VERB:  4
            # COLOR OF  zero -VERB:  #088A85
            # ======================================================================
            # ANALYZED BY FUNCTION KNOWLEDGE:
            # 
            #  CHECK-SUM-KEYS  :  1397
            # 
            #  CHECK-SUM-TENSE  :  519
            # 
            #  ESTIMATED-COUNT-TENSE  :  173
            # 
            #  TOTAL-COUNT-ALPHA  :  27
            # 
            #  TOTAL-COUNT-GRAPH  :  878
            # 
            #  TOTAL-COUNT-KEYS  :  1397
            # 
            #  TOTAL-COUNT-TENSE  :  519
            # 
            #  TOTAL-COUNT-TENSE1  :  172
            # 
            #  TOTAL-COUNT-TENSE2OR3  :  347
            # 
            #  TOTAL-WARNINGS  :  0          
        else:
            print('~' *33)          
            print('(Step 4/33) OF TEST_OBJECT4XI: ** SKIPPED ANALYZE BY FUNCTION - DEBUG2ANALYZE SET TO FALSE - SET TO TRUE, IF YOU WANT IT **')
            print('~' *33)              
              
        # ---------------------------------------------------------------------------------------------
        # WAVE using function - OPTIONAL                           
        # ---------------------------------------------------------------------------------------------    
        debug2wave = False
        
        if debug2wave is True:        
            print('=' *33)          
            print('(Step 5/33) OF TEST_OBJECT4XI: WAVE VERBS BY FUNCTION', time4xi())
            print('=' *33)      
            
            kb2xi = wave_verb4xi()
            keys2kb = kb2xi.keys() 
    
            print('=' *70) 
            print("(Step 6/33) OF TEST_OBJECT4XI: WAVED VERBS BY FUNCTION:")
            
            
            for key2kb in sorted(keys2kb):
                print('\n', key2kb, ' : ', kb2xi[key2kb])
            #  'show':      ('show', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to cause to be seen; exhibit;display.', 2, 3, '#BFF9E7'), 
            #  'skip':      ('skip', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to pass over without reading, acting, calculating etc.', 2, 3, '#F78181'), 
            #  'terminate': ('terminate', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to end, conclude or cease.', 2, 3, '#FE2E2E'), 
            #  'yearn':     ('yearn', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to have a strong desire.', 2, 3, '#8000FF'), 
            #  'kill':      ('kill', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to stop the operation of (process, task, etc.).', 2, 3, '#E15252'), 
            #...   
                
        else:
            print('~' *33)          
            print('(Step 7/33) OF TEST_OBJECT4XI: ** SKIPPED WAVE BY FUNCTION - DEBUG2WAVE SET TO FALSE - SET TO TRUE, IF YOU WANT IT**')
            print('~' *33)   
                                              
        # ---------------------------------------------------------------------------------------------
        # SENSE using function - OPTIONAL                           
        # ---------------------------------------------------------------------------------------------    
        debug2sense = False
        
        if debug2sense is True:     
        
            print('=' *33)          
            print('(Step 8A/33) OF TEST_OBJECT4XI: SENSE BY FUNCTION')
            print('=' *33)      
        
            kb2xi = sense_verb4xi()
        
            print("(Step 8B/33) OF TEST_OBJECT4XI: SENSED BY FUNCTION KNOWLEDGE = ", kb2xi)
        else:
            print('~' *33)          
            print('(Step 8C/33) OF TEST_OBJECT4XI: ** SKIPPED SENSE BY FUNCTION - DEBUG2SENSE SET TO FALSE - SET TO TRUE, IF YOU WANT IT**')
            print('~' *33)
                       
        # ---------------------------------------------------------------------------------------------
        # REASON using function - OPTIONAL                           
        # ---------------------------------------------------------------------------------------------    
        debug2reason = False
        
        if debug2reason is True:     
            print('=' *33)          
            print('(Step 9A/33) OF TEST_OBJECT4XI: REASON BY FUNCTION')
            print('=' *33)       
        
            kb4xi = reason_verb4xi()
            print("(Step 9B/33) OF TEST_OBJECT4XI: REASONED BY FUNCTION KNOWLEDGE = ", kb4xi)
        else:
            print('~' *33)          
            print('(Step 9C/33) OF TEST_OBJECT4XI: ** SKIPPED REASON BY FUNCTION - DEBUG2REASON SET TO FALSE - SET TO TRUE, IF YOU WANT IT**')
            print('~' *33)
            
                    
        # ---------------------------------------------------------------------------------------------
        # ACE using function - OPTIONAL                           
        # ---------------------------------------------------------------------------------------------    
        debug2ace = False
        if debug2ace is True:           
            print('=' *33)          
            print('(Step 10A/33) OF TEST_OBJECT4XI: ACE BY FUNCTION')
            print('=' *33)       
        
            kb8xi = ace_verb4xi()
            print("(Step 10B/33) OF TEST_OBJECT4XI: ACED BY FUNCTION KNOWLEDGE = ", kb8xi)    
        else:
            print('~' *33)          
            print('(Step 10C/33) OF TEST_OBJECT4XI: ** SKIPPED ACE BY FUNCTION - DEBUG2ACE SET TO FALSE - SET TO TRUE, IF YOU WANT IT**')
            print('~' *33)
                   
        # ---------------------------------------------------------------------------------------------
        # create class object - MANDATORY                           
        # ---------------------------------------------------------------------------------------------       
        v2xi = Verb4Xi()
              
        # ---------------------------------------------------------------------------------------------
        # ANALYZE using class object - OPTIONAL                           
        # ---------------------------------------------------------------------------------------------    
        debug2analyze = False        
        
        if debug2analyze is True:
            print('=' *33)          
            print('(Step 11A/33) OF TEST_OBJECT4XI: ANALYZE BY CLASS')
            print('=' *33)      
        
            kb2xi = v2xi.analyze_verb()
            keys2kb = kb2xi.keys() 
        
            print("(Step 11B/33) OF TEST_OBJECT4XI: ANALYZED BY CLASS OBJECT")
        
            for key2kb in sorted(keys2kb):
                print('\n', key2kb, ' : ', kb2xi[key2kb])
        else:
            print('~' *33)          
            print('(Step 11C/33) OF TEST_OBJECT4XI: ** SKIPPED ANALYZE BY CLASS - DEBUG2ANALYZE SET TO FALSE - SET TO TRUE, IF YOU WANT IT**')
            print('~' *33)        
              
        # ---------------------------------------------------------------------------------------------
        # COLOR using class object - OPTIONAL                           
        # ---------------------------------------------------------------------------------------------    
        debug2color = False  
        
        if debug2color is True:
            print('=' *33)          
            print('(Step 12A/33) OF TEST_OBJECT4XI: COLOR TENSES BY CLASS')
            print('=' *33)      
        
            kb2xi = v2xi.color_tenses()
            keys2kb = kb2xi.keys() 
        
            print("(Step 12B/33) OF TEST_OBJECT4XI: COLORED BY CLASS OBJECT")
        
            for key2kb in sorted(keys2kb):
                print('\n', key2kb, ' : ', kb2xi[key2kb])            
        else:
            print('~' *33)          
            print('(Step 12C/33) OF TEST_OBJECT4XI: ** SKIPPED COLOR TENSES BY CLASS - DEBUG2COLOR SET TO FALSE - SET TO TRUE, IF YOU WANT IT**')
            print('~' *33)                    
              
        # ---------------------------------------------------------------------------------------------
        # COORDINATE VERBS using class object - MANDATORY                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 14A/33) OF TEST_OBJECT4XI: COORDINATING TENSES BY CLASS')
        print('=' *33)      
        
        v2xi.coordinate_tenses('..//..//xml//reason-test-skeleton-print4xi.xml')
        
        print("(Step 14B/33) OF TEST_OBJECT4XI: COORDINATED TENSES BY CLASS OBJECT")
        
          
            
                        
            
        # ---------------------------------------------------------------------------------------------
        # SENSE using class object - OPTIONAL                         
        # ---------------------------------------------------------------------------------------------    
        ack2sense = False
        if ack2sense is True:
            print('=' *33)          
            print('(Step 15A/33) OF TEST_OBJECT4XI: SENSE BY CLASS')
            print('=' *33)      
            
            kb2xi = v2xi.sense_verb()
            print("(Step 15B/33) OF TEST_OBJECT4XI: SENSED BY CLASS KNOWLEDGE = ", kb2xi)
            
        else:
            print('~' *33)          
            print('(Step 15C/33) OF TEST_OBJECT4XI: ** SKIPPED SENSE BY CLASS - ACK2SENSE SET TO FALSE - SET TO TRUE, IF YOU WANT IT**')
            print('~' *33)                 


        
        # ---------------------------------------------------------------------------------------------
        # REASON using class object - OPTIONAL                     
        # ---------------------------------------------------------------------------------------------    
        ack2reason = False
                
        if ack2reason is True:
            print('=' *33)          
            print('(Step 16A/33) OF TEST_OBJECT4XI: REASON BY CLASS')
            print('=' *33)       
            
            kb4xi = v2xi.reason_verb()
            print("(Step 16B/33) OF TEST_OBJECT4XI: REASONED BY CLASS KNOWLEDGE = ", kb4xi)
        else:
            print('~' *33)          
            print('(Step 16C/33) OF TEST_OBJECT4XI: ** SKIPPED REASON BY CLASS - ACK2REASON SET TO FALSE - SET TO TRUE, IF YOU WANT IT**')
            print('~' *33)
                         
        # ---------------------------------------------------------------------------------------------
        # ACE using class object - OPTIONAL                        
        # ---------------------------------------------------------------------------------------------    
        ack2ace = False
        
        if ack2ace is True:
            print('=' *33)          
            print('(Step 17A/33) OF TEST_OBJECT4XI: ACE BY CLASS')
            print('=' *33)       
            
            kb8xi = v2xi.ace_verb()
            print("(Step 17B/33) OF TEST_OBJECT4XI: ACED BY CLASS KNOWLEDGE = ", kb8xi)
        else:
            print('~' *33)          
            print('(Step 17C/33) OF TEST_OBJECT4XI: ** SKIPPED ACE BY CLASS - ACK2ACE SET TO FALSE - SET TO TRUE, IF YOU WANT IT**')
            print('~' *33)
                    
        # ---------------------------------------------------------------------------------------------
        # XML using class object - MANDATORY                    
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 18A/33) OF TEST_OBJECT4XI: XML BY CLASS')
        print('=' *33)       
        
        v2xi.xml_verb()
        print("(Step 18B/33) OF TEST_OBJECT4XI: XML BY CLASS CREATED XML FILE REASON-VERB4XI.XML")
                        
        # ---------------------------------------------------------------------------------------------
        # DONE                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 33/33) OF TEST_OBJECT4XI: DONE!')
        print('=' *33)
        
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
         
       
#</function4xi>

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for test_object4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():

    print('=' *33)
    print("SENSING IT WITH YOURDRAGONXI ", time4xi())  
    print('=' *33)
        
    test_object4xi()    
    
    print('=' *33)
    print("SENSED IT WITH YOURDRAGONXI ", time4xi())    
    print('=' *33) 
                              
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
    
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_object4xi.txt
#   reason-test-verbkb4xi.xml
#
#   Note: sense and ace are not referred because only verbs are being tested and reason XMl created
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_object4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
